#include <string.h>


static JSValueRef myWindowGetProperty(JSContextRef ctx, JSObjectRef object, JSStringRef propertyNameJS, JSValueRef* exception)
{
	size_t          len     = JSStringGetMaximumUTF8CStringSize(propertyNameJS);
	char*           propertyName   =  (char*)malloc(len);
	JSStringGetUTF8CString(propertyNameJS, propertyName, len);
	
	JSValueRef returningValue = JSValueMakeUndefined(ctx);
	
	if (strcmp(propertyName, "Test") == 0)
	{
		return JSValueMakeNumber(ctx,  123);
	}else if (strcmp(propertyName, "propertyName") == 0) {
		return JSValueMakeNumber(ctx,  456);
	}else {//不明な値の場合
		JSStringRef string = JSStringCreateWithUTF8CString("Property not found.");
		JSValueRef exceptionString = 	JSValueMakeString(ctx, string);
		JSStringRelease(string);
		*exception = JSValueToObject(ctx, exceptionString, NULL);
		return NULL;
	}

	free(propertyName);
	return JSValueMakeUndefined(ctx);
}

void classMywindow(JSGlobalContextRef ctx, JSObjectRef jobjGlobal, JSObjectRef* classObject)
{
	//クラスの定義を保持する変数を作成
	JSClassDefinition classDefinition	= kJSClassDefinitionEmpty;
	//クラス型の変数を作成
	JSClassRef classSubstance;
	//クラスの名前を決定
	classDefinition.className = name;
	//クラスのコールバック関数
	classDefinition.getProperty = myWindowGetProperty;
	
	
	//プロトタイプは手動で作成という事にする
	//classDefinition.attributes = kJSClassAttributeNoAutomaticPrototype; 
	//クラス型を作成
	classSubstance = JSClassCreate(&classDefinition);
	//クラスをオブジェクト化
	*classObject = JSObjectMakeConstructor(ctx, classSubstance, NULL);
	//クラスを持ったオブジェクトの名前を作る
	JSStringRef jstr = JSStringCreateWithUTF8CString(name);
	//関数にしちゃう
	JSValueRef jconst = JSObjectCallAsConstructor(ctx, *classObject, 0, NULL, NULL);
	//クラスのオブジェクトをCTXに公開
	JSObjectSetProperty(ctx, jobjGlobal, jstr, jconst, kJSPropertyAttributeNone, NULL);
	//JSObjectCallAsConstructor(ctx,*classObject,0,NULL,NULL);
	// 文字列のリファレンスカウンタをデクリメント
    JSStringRelease(jstr);
}